#include <REGX51.H>
sbit rs= P3^5; 
sbit rw= P2^1; 
sbit en= P3^4;
////////////////////////////////////Delay////////////////////////////////////
void mdelay(unsigned int itime)
{
unsigned int i,j; 
for(i=0;i<itime;i++)
for(j=0;j<1275;j++);
}
/// / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / L C D COMMAND////////////////////////////////////
void lcdcmd(unsigned char value)
{
P1=value; 
rs=0;
rw=0;
en=1;
mdelay(1);
en=0;
}
void lcd_data(unsigned char value)
{

P1=value; 
rs=1; 
rw=0; 
en=1; 
mdelay(1); 
en=0;
}
/////////////////////////////////STRING LCD////////////////////////////////
void string_lcd(unsigned char *ptr)
{
    unsigned int h,j = 0, k = 0;
    while(*ptr)
    {
        h++;
        if(h<15)
        {
            lcdcmd(0x80 + k);
            lcd_data(*ptr++);
            k++;
            
        }
        else if(h>=15 && h<=31)
        {
 
            lcdcmd(0xC0 + j);
            lcd_data(*ptr++);
            j++;
            
        }
        else if(h>31 && h<47)
        {
            h = 0;
            j = 0;
            k = 0;
            mdelay(300);
            lcdcmd(0x01);
            lcdcmd(0x80);
            lcdcmd(0x06);
            lcd_data(*ptr++);
        }
 
        //if(h>=47)
        //{
            //lcdcmd(0xC0+j);
            //lcd_data(*ptr++);
            //j++;
        //}
        //mdelay(250);
        //lcdcmd(0x18);
        //}
        //  *(ptr++);
        //}
    }
}

//INITIALIZATION///////////////////////////////
void uart_init()
{
TMOD=0x20; 
TH1=0xFD;
SCON=0x50; 
TR1=1;
}
/// / / / / / / / / / / / / / / / / / / / / / / / / / / / / L C D INITIALIZATION//////////////////////////////
void lcd_init()
{
lcdcmd(0x38);
//mdelay(250);
lcdcmd(0x0F);
//mdelay(250);
lcdcmd(0x01);
//mdelay(250); 
lcdcmd(0x06); 

} //mdelay(250);

void main()
{

unsigned char str2[100],*ptr;
unsigned int i; 
ptr=str2; 
uart_init(); 
lcd_init();

while(SBUF!=0x0D)	//Checking if the enter is pressed or not
{
while(RI==0);
 RI=0; 
 str2[i]=SBUF; 
 i++;
}
str2[i]='\0';
string_lcd(ptr);
// To display on LCD
 for(i=0;i<6;i++)
{
lcd_data(str2[i]);
}
while(1);
}